Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## Jama
Class LUDecomposition

    java.lang.Object
      |
      +--Jama.LUDecomposition

public class LUDecomposition
extends java.lang.Object
implements java.io.Serializable

LU Decomposition.

For an m-by-n matrix A with m >= n, the LU decomposition is an m-by-n unit lower triangular matrix L, an n-by-n upper triangular matrix U, and a permutation vector piv of length m so that A(piv,:) = L*U. If m < n, then L is m-by-m and U is m-by-n.

The LU decompostion with pivoting always exists, even if the matrix is singular, so the constructor will never fail. The primary use of the LU decomposition is in the solution of square systems of simultaneous linear equations. This will fail if isNonsingular() returns false.

See Also:
  Serialized Form

Constructor Summary
`LUDecomposition(Matrix A)` LU Decomposition

Method Summary
`double` | `det()` Determinant
`double[]` | `getDoublePivot()` Return pivot permutation vector as a one-dimensional double array
`Matrix` | `getL()` Return lower triangular factor
`int[]` | `getPivot()` Return pivot permutation vector
`Matrix` | `getU()` Return upper triangular factor
`boolean` | `isNonsingular()` Is the matrix nonsingular?
`Matrix` | `solve(Matrix B)` Solve A*X = B

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### LUDecomposition

    public LUDecomposition(Matrix A)

  LU Decomposition
  Parameters:
    `A` - Rectangular matrix

Method Detail

### isNonsingular

    public boolean isNonsingular()

  Is the matrix nonsingular?
  Returns:
    true if U, and hence A, is nonsingular.

### getL

    public Matrix getL()

  Return lower triangular factor
  Returns:
    L

### getU

    public Matrix getU()

  Return upper triangular factor
  Returns:
    U

### getPivot

    public int[] getPivot()

  Return pivot permutation vector
  Returns:
    piv

### getDoublePivot

    public double[] getDoublePivot()

  Return pivot permutation vector as a one-dimensional double array
  Returns:
    (double) piv

### det

    public double det()

  Determinant
  Returns:
    det(A)
  Throws:
    java.lang.IllegalArgumentException - Matrix must be square

### solve

    public Matrix solve(Matrix B)

  Solve A*X = B
  Parameters:
    `B` - A Matrix with as many rows as A and any number of columns.
  Returns:
    X so that L*U*X = B(piv,:)
  Throws:
    java.lang.IllegalArgumentException - Matrix row dimensions must agree.
    java.lang.RuntimeException - Matrix is singular.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD